#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "datatypes.h"
#include "lavadero.h"

void *trabajador(void *); 

//crea un TAD lavadero con t maquinas
lavadero
lavadero_crear(int t) {
	lavadero l;
	
	assert(0<t);
	l = (lavadero) malloc(sizeof(struct lavadero_s));
	if (l) {
		int i;
		l->tamanio = t;
		l->disponibles = (bool *) malloc(t*sizeof(bool));
		for(i=0; i<t; i++) l->disponibles[i] = TRUE;
	}
	
	return(l);
}


//libera la memoria del TAD
void
lavadero_destruir(lavadero l) {
	assert(l);
	assert(l->disponibles);
	free(l->disponibles);
	free(l);
}


//cuantas maquinas tiene el lavadero
int
lavadero_tamanio(lavadero l) {
	return(l->tamanio);
}


//pide una maquina libre al lavadero l
//si no hay libres devuelve NO_MAQUINA
maquina
lavadero_pedir_maquina(lavadero l) {
	int encontrada;
	maquina m;
	assert(l);
	assert(l->disponibles);
	encontrada = FALSE;
	m = 0;
	while (!encontrada && m<l->tamanio) {
		if (l->disponibles[m]) {
			l->disponibles[m] = FALSE;
			encontrada = TRUE;
		} else
			m++;
	}
	if (encontrada) return(m);
	else		return(NO_MAQUINA);
}


//desocupa la maquina m del lavadero l
void
lavadero_devolver_maquina(lavadero l, maquina m) {
	assert(l);
	assert(l->disponibles);
	assert(0<=m && m<l->tamanio);
	l->disponibles[m] = TRUE;
}


//indica si la maquina m esta libre en el lavadero l
bool
lavadero_libre_maquina(lavadero l, maquina m) {
	assert(l);
	assert(l->disponibles);
	assert(0<=m && m<l->tamanio);
	return(l->disponibles[m]);
}
