#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>

#include "datatypes.h"
#include "lavadero.h"

#ifdef INTERLEAVINGS
#define YIELD sched_yield()
#endif

#define NUM_PERSONAS 6 
#define NUM_CICLOS_VIDA 8 
#define NUM_MAQUINAS 2 

//variables globales y compartidas entre los threads
lavadero l;


//funcion que ejecutaran los threads, le pasamos un numero que indentifica la
//persona
void *abstraccion_de_persona(void *ptr) {
	maquina m;
	int p;	//id de la persona
	int i;
	
	p = *((int *) ptr);
	
	printf("Persona %d: he NACIDO\n",p);
	for(i=0; i<NUM_CICLOS_VIDA; i++) {
		/*vivir*/
		printf("Persona %d ciclo %d: viviendo\n",p,i);
		
		m = lavadero_pedir_maquina(l);
		if (m==NO_MAQUINA) {
			printf("Persona %d ciclo %d: NO puedo conseguir maquina, no puedo continuar viviendo\n",p,i);
			pthread_exit(NULL);
		}
		printf("Persona %d ciclo %d: obtuve la maquina %d\n",p,i,m);
		
		/*lavar en la maquina m*/
		printf("Persona %d ciclo %d: lavando en la maquina %d\n",p,i,m);
		
		lavadero_devolver_maquina(l,m);
		printf("Persona %d ciclo %d: devuelvo la maquina %d\n",p,i,m);
	}
	printf("Persona %d: he MUERTO\n",p);
	pthread_exit(NULL);
}


//------------
//  el MAIN
//------------

int
main (int argc, char *argv[])
{
	pthread_t threads[NUM_PERSONAS];
	int idpersonas[NUM_PERSONAS];
	int i;

#ifdef NO_PROB_1 
	printf("Compilado con NO_PROB_1\n");
#endif
#ifdef NO_PROB_2
	printf("Compilado con NO_PROB_2\n");
#endif

	l = lavadero_crear(NUM_MAQUINAS);
	for(i=0; i<NUM_PERSONAS; i++)
		idpersonas[i] = i;

	//creacion de los hilos
	for (i=0; i<NUM_PERSONAS; i++)
		pthread_create(&threads[i],NULL,&abstraccion_de_persona,(void *) &idpersonas[i]);
	
	//esperamos que todos terminen, o sea nunca.
	for (i=0; i<NUM_PERSONAS; i++)
		pthread_join(threads[i],NULL);

	return 0;
}
